<?php
	
	class DatabaseConnection extends PDO
	{
		protected static $_singleton = null;
		
		public static function getInstance()
		{
			if (self::$_singleton === null)
			{
				$config = include ROOT_PATH . 'config.php';
				
				$engine 	= $config['global']['database']['engine'];
				$hostname 	= $config['global']['database']['options']['hostname'];
				$username 	= $config['global']['database']['options']['username'];
				$password 	= $config['global']['database']['options']['password'];
				$database 	= $config['global']['database']['options']['database'];

				try
				{
					self::$_singleton = new self("{$engine}:dbname={$database};host={$hostname}", $username, $password, array(
						PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION
					));
				}
				catch (PDOException $e)
				{
					trigger_error("<code>Error code : {$e->getCode()}" . PHP_EOL . "<br />Error message : {$e->getMessage()}" . PHP_EOL . "</code><br />" . PHP_EOL, E_USER_WARNING);
				}
			}
				
			return self::$_singleton;
		}
	}

?>